//=======================================================================================
//
//		primitive.h[スプライト以外のポリゴン]
//    	AT12A242　(名前)	2017/05/19
//
//=======================================================================================
#ifndef _PRIMITIVE_H_
#define _PRIMITIVE_H_


#include <revolution.h>
#include <revolution/kpad.h>	// Vec2


//------------------------------------------------------------------------
//	グローバル変数
static u8 primitiveR = 255;	//デフォルトは白
static u8 primitiveG = 255;
static u8 primitiveB = 255;

//------------------------------------------------------------------------
//	関数定義

//=======================================================================================
// 図形描画準備関数
// PrimitiveのDraw関数を呼ぶ前にコールする
// ※他のSetup関数が呼ばれた後、PrimitiveのDraw関数を呼ぶ場合には再度コールすること
void PrimitiveSetup(void);	

//=======================================================================================
// 図形色設定関数
// 図形色を指定する
// この関数が呼ばれた後の図形はすべてここで指定した色になる
// r ... 赤要素(0-255)
// g ... 緑要素(0-255)
// b ... 青要素(0-255)
void PrimitiveSetColor(u8 r, u8 g, u8 b);

//=======================================================================================
// 点の描画
// x, y ... 点の描画座標
void PrimitiveDrawPoint(float x, float y);	//点の描画

//=======================================================================================
// 線の描画
// x0, y0 ... 線の始点座標
// x1, y1 ... 線の終点座標
void PrimitiveDrawLine(float x0, float y0, float x1, float y1);	//線の描画

//=======================================================================================
// 四角の描画
// x, y ... 四角の左上座標
// w, h ... 四角の幅と高さ
void PrimitiveDrawRectangle(float x, float y, float w, float h);	//四角のライン描画		

//=======================================================================================
// 塗りつぶされた多角形の描画
// 座標をいくつも登録してその座標を頂点とする多角形を描画する
// v   ... 座標配列の先頭アドレス
// num ... 座標の数
void PrimitiveDrawPolygon(Vec2 v[], u16 num);

//=======================================================================================
// 塗りつぶし四角の描画
// x, y ... 四角の左上座標
// w, h ... 四角の幅と高さ
void PrimitiveDrawFillRectangle(float x, float y, float w, float h);

//=======================================================================================
// ラインの太さ
// nLineSize ... ラインの太さ
void LineSize(int nLineSize);

//=======================================================================================
// ラインの太さ
// nPointSize ... 点の太さ
void PointSize(int nPointSize);

#endif //_PRIMITIVE_H_